/* mz2mf does what ega2mf does but does it on the character ROM*/
/* from Sharp MZ-721 as downloaded from sharpmz.org (file MZ7CGint.zip) */
/* this means 8 x 8 glyphs.  There are 512 in the ROM.*/
/* So I am only looking at 256 at a time and will make 2 `fonts'.

/* This version changes the encoding to match cmtt in T1 */

/* Original comments*/

/* EGA2MF.C is Copyright 1990 Humanities and Arts Computing Center */
/* usage: ega2mf [egafontname] [metafont_sourcecode_output_file] */
/* suggestions to ridgeway@blake.acs.washington.edu */

/* history: */
/* v. 1.0 released 4/16/1990 */

#include <stdio.h>
#include <string.h>



/* the charblock structure is used for processing each character */
typedef struct {
               unsigned char column[8];
               } videorow;
typedef struct {
                videorow row[8];
               } charblock;

/* the MZ font is a naked 8x8 bitmap 512 chars deep */
typedef struct {
                unsigned char bitmap[8];
                } egachar;

typedef struct {
	       egachar charset[256];
               } egafont;

/* globally accessible area */
charblock editchar;
/* global vars  and strings */
char infilename[128];
char outfilename[128];

/* encoding  -- added by DJG April 2015 */
int encoding[255];

jumpout() { exit(1); }

void copyright()
{
  puts("Hacked up by Darren Goossens\n");
  puts("Origtinal comments below.\n");
  puts("-------------------------------------------");
  puts("Ega2Mf  Screen font --> METAFONT code generator\n");
  puts("HUMANITIES AND ARTS COMPUTING CENTER, DR-10");
  puts("UNIVERSITY OF WASHINGTON, SEATTLE WA 98195 USA\n");
  puts("Copyright 1990 Humanities and Arts Computing Center\n");
  puts("This software may be used, modified, and redistributed free of any");
  puts("fee or royalty, provided that this copyright and 'free software' notice");
  puts("remains intact in any copies redistributed, and that you may charge no fee");
  puts("of any sort whatsoever without the written permission of the Humanities");
  puts("and Arts Computing Center.");
  return;
}


void exists (char *filename) 
  { 
    unsigned char response;
    FILE *handle;
    handle = fopen ( filename , "rb" ) ; 
    if (handle != (FILE *) NULL) 
       {  fclose(handle);
          printf("File %s already exists: O.K. to replace? (Y/N): ", filename);
          response = getchar();
          if ( ! ( (response=='y') || (response=='Y') ) ) 
            {
            printf("\nPlease rename files as necessary and try again.\n");
            jumpout();
            }
       }
    return;
    } 

FILE *getopen(char *filename, char *access)
{
	int	temp;
	FILE	*handle;
	gets(filename);
	if (access[0]=='w' || access[0]=='W') exists(filename);  
	handle=fopen(filename,access);
	if (handle == NULL) {
	  puts("\nCan't open file ");
	  puts(filename);
	  puts("\n");
	  }
	return handle;
}

FILE *get_file(char *access,char *prompt,char *filename)
{
	printf("\n %s",prompt);
	return getopen(filename,access);
}

void makedisplay(unsigned char thischar, egafont *thisfont)
{
  int temp,mask,i,k,hold;
  for (i=0; i<8;i++) {
    temp=thisfont->charset[thischar].bitmap[i];
    mask=0x80;
    for (k=0; k<8; k++) {
      hold=temp & mask;
      if (hold==0) editchar.row[i].column[k]=0;
      else editchar.row[i].column[k]=1;
      mask=mask / 2;
    } /* endfor k */
  } /* endfor i */
  return;
}


main(int argc, char *argv[])
{
/* encoding here DJG April 2015*/

  encoding[0]=0;
  encoding[1]=65;  
  encoding[2]=66;  
  encoding[3]=67;  
  encoding[4]=68;  
  encoding[5]=69;  
  encoding[6]=70;  
  encoding[7]=71;  
  encoding[8]=72;  
  encoding[9]=73;  
  encoding[10]=74;
  encoding[11]=75;  
  encoding[12]=76;  
  encoding[13]=77;  
  encoding[14]=78;  
  encoding[15]=79;  
  encoding[16]=80;  
  encoding[17]=81;  
  encoding[18]=82;  
  encoding[19]=83;  
  encoding[20]=84;
  encoding[21]=85;  
  encoding[22]=86;  
  encoding[23]=87;  
  encoding[24]=88;  
  encoding[25]=89;  
  encoding[26]=90;  
  encoding[27]=191;  
  encoding[28]=1;  
  encoding[29]=2;  
  encoding[30]=3;
  encoding[31]=4;  
  encoding[32]=48;  
  encoding[33]=49;  
  encoding[34]=50;  
  encoding[35]=51;  
  encoding[36]=52;  
  encoding[37]=53;  
  encoding[38]=54;  
  encoding[39]=55;  
  encoding[40]=56;
  encoding[41]=57;  
  encoding[42]=45;  
  encoding[43]=61;  
  encoding[44]=59;  
  encoding[45]=47;  
  encoding[46]=46;  
  encoding[47]=44;  
  encoding[48]=5;  
  encoding[49]=6;  
  encoding[50]=7;
  encoding[51]=8;  
  encoding[52]=9;  
  encoding[53]=10;  
  encoding[54]=11;  
  encoding[55]=12;  
  encoding[56]=13;  
  encoding[57]=14;  
  encoding[58]=15;  
  encoding[59]=16;  
  encoding[60]=17;
  encoding[61]=18;  
  encoding[62]=19;  
  encoding[63]=20;  
  encoding[64]=125;  
  encoding[65]=21;  
  encoding[66]=22;  
  encoding[67]=23;  
  encoding[68]=24;  
  encoding[69]=25;  
  encoding[70]=26;
  encoding[71]=27;  
  encoding[72]=28;  
  encoding[73]=63;  
  encoding[74]=29;  
  encoding[75]=30;  
  encoding[76]=31;  
  encoding[77]=32;  
  encoding[78]=127;  
  encoding[79]=58;  
  encoding[80]=128;
  encoding[81]=60;  
  encoding[82]=91;  
  encoding[83]=129;  
  encoding[84]=93;  
  encoding[85]=64;  
  encoding[86]=130;  
  encoding[87]=62;  
  encoding[88]=131;  
  encoding[89]=92;  
  encoding[90]=132;
  encoding[91]=133;  
  encoding[92]=134;  
  encoding[93]=135;  
  encoding[94]=136;  
  encoding[95]=137;  
  encoding[96]=138;  
  encoding[97]=33;  
  encoding[98]=34;  
  encoding[99]=35;  
  encoding[100]=36;
  encoding[101]=37;  
  encoding[102]=38;  
  encoding[103]=39;  
  encoding[104]=40;  
  encoding[105]=41;  
  encoding[106]=43;  
  encoding[107]=42;  
  encoding[108]=139;  
  encoding[109]=140;  
  encoding[110]=141;
  encoding[111]=142;  
  encoding[112]=143;  
  encoding[113]=144;  
  encoding[114]=145;  
  encoding[115]=146;  
  encoding[116]=147;  
  encoding[117]=124;  
  encoding[118]=148;  
  encoding[119]=149;  
  encoding[120]=150;
  encoding[121]=151;  
  encoding[122]=152;  
  encoding[123]=153;  
  encoding[124]=154;  
  encoding[125]=155;  
  encoding[126]=156;  
  encoding[127]=157;  
  encoding[128]=158;  
  encoding[129]=97;  
  encoding[130]=98;
  encoding[131]=99;  
  encoding[132]=100;  
  encoding[133]=101;  
  encoding[134]=102;  
  encoding[135]=103;  
  encoding[136]=104;  
  encoding[137]=105;  
  encoding[138]=106;  
  encoding[139]=107;  
  encoding[140]=108;
  encoding[141]=109;  
  encoding[142]=110;  
  encoding[143]=111;  
  encoding[144]=112;  
  encoding[145]=113;  
  encoding[146]=114;  
  encoding[147]=115;  
  encoding[148]=116;  
  encoding[149]=117;  
  encoding[150]=118;
  encoding[151]=119;  
  encoding[152]=120;  
  encoding[153]=121;  
  encoding[154]=122;  
  encoding[155]=228;  
  encoding[156]=159;  
  encoding[157]=160;  
  encoding[158]=161;  
  encoding[159]=162;  
  encoding[160]=163;
  encoding[161]=164;  
  encoding[162]=165;  
  encoding[163]=166;  
  encoding[164]=96;  
  encoding[165]=126;  
  encoding[166]=167;  
  encoding[167]=168;  
  encoding[168]=169;  
  encoding[169]=170;  
  encoding[170]=255;
  encoding[171]=252;  
  encoding[172]=246;  
  encoding[173]=220;  
  encoding[174]=196;  
  encoding[175]=214;  
  encoding[176]=171;  
  encoding[177]=172;  
  encoding[178]=173;  
  encoding[179]=174;  
  encoding[180]=175;
  encoding[181]=176;  
  encoding[182]=177;  
  encoding[183]=178;  
  encoding[184]=179;  
  encoding[185]=180;  
  encoding[186]=181;  
  encoding[187]=182;  
  encoding[188]=123;  
  encoding[189]=183;  
  encoding[190]=94;
  encoding[191]=95;  
  encoding[192]=184;  
  encoding[193]=185;  
  encoding[194]=186;  
  encoding[195]=187;  
  encoding[196]=188;  
  encoding[197]=189;  
  encoding[198]=190;  
  encoding[199]=192;  
  encoding[200]=193;
  encoding[201]=194;  
  encoding[202]=195;  
  encoding[203]=197;  
  encoding[204]=223;  
  encoding[205]=199;  
  encoding[206]=200;  
  encoding[207]=201;  
  encoding[208]=202;  
  encoding[209]=203;  
  encoding[210]=204;
  encoding[211]=205;  
  encoding[212]=206;  
  encoding[213]=207;  
  encoding[214]=208;  
  encoding[215]=209;  
  encoding[216]=210;  
  encoding[217]=211;  
  encoding[218]=212;  
  encoding[219]=213;  
  encoding[220]=215;
  encoding[221]=216;  
  encoding[222]=217;  
  encoding[223]=218;  
  encoding[224]=219;  
  encoding[225]=221;  
  encoding[226]=227;  
  encoding[227]=198;  
  encoding[228]=229;  
  encoding[229]=230;  
  encoding[230]=231;
  encoding[231]=232;  
  encoding[232]=233;  
  encoding[233]=234;  
  encoding[234]=235;  
  encoding[235]=236;  
  encoding[236]=237;  
  encoding[237]=238;  
  encoding[238]=239;  
  encoding[239]=240;  
  encoding[240]=241;
  encoding[241]=242;  
  encoding[242]=243;  
  encoding[243]=244;  
  encoding[244]=245;  
  encoding[245]=247;  
  encoding[246]=248;  
  encoding[247]=249;  
  encoding[248]=250;  
  encoding[249]=251;  
  encoding[250]=253;
  encoding[251]=254;  
  encoding[252]=222;  
  encoding[253]=224;  
  encoding[254]=225;  
  encoding[255]=226;  
  
  FILE *f1=(FILE *) NULL;
  FILE *f2=(FILE *) NULL;
  int done,ch,i,k,codeout;
  char quote,percent;
  egafont *thisega;
  quote=34;
  percent=37;
  /* yes, yes! we are assuming the ASCII character set */
  copyright();
  thisega = (egafont *) malloc(sizeof(egafont));
  if (argc > 1) {
    f1 = fopen(argv[1],"rb");
    (void) strcpy(infilename,argv[1]);
    }
  if (f1 == (FILE *) NULL) {
	/* prompt for and open input file */
	for ( ; f1 == (FILE *) NULL; f1=get_file("rb","Enter name of input MZ ROM font file: ",infilename)) ;
	/*for ( ; f1 == (FILE *) NULL; f1=get_file("rb","Enter name of input ega font file: ",infilename)) ;*/
	}
  fread(thisega,sizeof(egafont),1,f1);
  fclose(f1);
  if (argc > 2) {
    (void) strcpy(outfilename,argv[2]);
    exists(outfilename);
    f2 = fopen(argv[2],"w");
    }
  if (f2 == (FILE *) NULL) {
	/* prompt for and open output file */
	for ( ; f2 == (FILE *) NULL; f2=get_file("w","Enter name of output Metafont source file: ",outfilename)) ;
	}
   fprintf(f2,"%c This is %s generated by MZ2MF from %s.\n",percent,outfilename,infilename);
   /*fprintf(f2,"%c This is %s generated by EGA2MF from %s.\n",percent,outfilename,infilename);*/
   fprintf(f2,"if unknown cmbase: input cmbase fi\n");
   fprintf(f2,"mode_setup;\n");
   fprintf(f2,"def generate suffix t= enddef;\n");
   fprintf(f2,"input hacked; font_setup;\n");
/*   fprintf(f2,"input cmtt10; font_setup;\n");*/
   fprintf(f2,"if ligs>1: font_coding_scheme:=%cTeX text%c;\n",quote,quote);
   fprintf(f2,"else: font_coding_scheme:=if ligs=0: %cTeX typewriter text%c\n",quote,quote);
   fprintf(f2,"  else: %cTeX text without f-ligatures%c fi; fi \n",quote,quote);
   fprintf(f2,"numeric cheight; cheight=body_height;\n");
/*   fprintf(f2,"numeric cheight; cheight=body_height+desc_depth;\n");*/
   fprintf(f2,"numeric hhalf; numeric vhalf; hhalf=.4u; vhalf=(cheight)/20.5;\n");
   /* 28 is 2*14, so replace with 16=2*8 */
   fprintf(f2,"numeric vcent; vcent=cheight/16; numeric hcent; hcent=9/16u;\n");
/*      fprintf(f2,"numeric vcent; vcent=cheight/28; numeric hcent; hcent=8/16u;\n"); */
   fprintf(f2,"def crt(expr row,col) =\n");
/*   fprintf(f2,"y.c:=body_height-(row * cheight / 8)-vcent; x.c:=hcent+(col * 9/8u);\n");*/
   fprintf(f2,"y.c:=body_height-(row * cheight / 8)-vcent; x.c:=hcent+(col * 8/8u);\n");
   fprintf(f2,"y.a:=y.c+vhalf; y.b:=y.c-vhalf;\n");
   fprintf(f2,"x.a:=x.c-hhalf; x.b:=x.c+hhalf;\n");
   fprintf(f2,"filldraw (x.a,y.b)--(x.a,y.a)--(x.b,y.a)--(x.b,y.b)--cycle;\n");
   fprintf(f2,"enddef;\n");
   printf("Now processing character ");
   for (ch=0; ch<256; ch++) {
     /* generate code for character ch */
     if ( (encoding[ch] < 32) || (encoding[ch] > 126) ) printf("[%d] ",encoding[ch]);
     else printf("[%c] ",encoding[ch]);
     /* change so height and width the same*/
/*         fprintf(f2,"\nbeginchar(%d,9u#,body_height#,desc_depth#);",ch);  */
     fprintf(f2,"\nbeginchar(%d,8u#,body_height#,desc_depth#);",encoding[ch]);
     fprintf(f2,"adjust_fit(0,0);\npickup pencircle scaled 0.2pt;\n");
     makedisplay(ch,thisega);
     for(i=0; i < 8; i++) {
        codeout=0;
        for(k=0; k<8; k++) {
	    if (editchar.row[i].column[k] != 0) {
                fprintf(f2,"crt(%d,%d); ",i,k);
                codeout=1;
                } /* endif set dot on */
        } /* end k */
        if (codeout > 0) fprintf(f2,"\n");
     } /* endfor i */
     fprintf(f2,"endchar;\n");
     if ( ( ch % 16 ) == 0 ) printf("\n");
   } /* endfor ch */
   fprintf(f2,"\n");
   fprintf(f2,"font_slant slant; font_x_height x_height#;\n");
   fprintf(f2," font_normal_space 9u#;\n");
   fprintf(f2," font_quad 18u#;\n");
   fprintf(f2," font_extra_space 9u#;\n");
   fprintf(f2,"bye.\n");
   printf("\nEGA2MF is done.  Good luck with your new font.\n");
   fclose(f2);
}

